#define N 4
unsigned i,j;

unsigned cnt = 0;
char counter = 0;
char buf_ch[N] = {0,0,0,0};
char lev_ch[N] = {0,0,0,0};
char pos_ch[N] = {1,1,1,1};
char min_ch[N] = {0,0,0,0};
char max_ch[N] = {50,150,200,200};
char pls_ch[N] = {1, 1, 1, 1};
char mns_ch[N] = {5, 5, 5, 7};
//------------------------------------------------------------------------------
// 
//------------------------------------------------------------------------------
void init_IO(){
     DDRC =  0b11111111; 
     PORTC = 0b00000000; 
     DDRD =  0b00000011;
     PORTD = 0b00000000;

     TCCR0 = 0x01;
     TOIE0_bit = 1;
     TCNT0 = 0;

asm sei;
//------------------------------------------------------------------------------
//       TMR0 ( )
//------------------------------------------------------------------------------
void timer0_overflow_ISR() org IVT_ADDR_TIMER0_OVF {
asm cli; 
  if (++counter==0)
  {
    for (i = 0; i < N; i++)
    {
        buf_ch[i] = lev_ch[i];
    }
    PORTC = 0xFF;
    PORTD = 0x03;
  }
  if (counter == buf_ch[0]) { PORTC0_bit = 0; PORTC1_bit = 0; }
  if (counter == buf_ch[1]) { PORTC2_bit = 0; PORTC3_bit = 0; }
  if (counter == buf_ch[2]) { PORTC4_bit = 0; PORTC5_bit = 0; }
  if (counter == buf_ch[3]) { PORTD0_bit = 0; PORTD1_bit = 0; }

asm sei;
}
//------------------------------------------------------------------------------
// MAIN
//------------------------------------------------------------------------------
void main() {
     init_IO();
     while(1) {
        for (j = 0; j < N; j++)
        {
            if (pos_ch[j] == 1)
            {
                lev_ch[j] += pls_ch[j];
                if (lev_ch[j] >= max_ch[j]) pos_ch[j] = 0;
            }
            else
            {
                lev_ch[j] -= mns_ch[j];
                if (lev_ch[j] <= min_ch[j]) pos_ch[j] = 1;
            }
        }
        Delay_ms(1);
        if (++cnt>500)
        {
            cnt = 0;
            for (j = 0; j < N; j++)
            {
                min_ch[j] = (char)rand() >> 2;
                max_ch[j] = (char)rand() << 2;
            }
        }
     }
}